# Class VulkanSubresourceLayout.Builder

java.lang.Object
com.io7m.jcoronado.api.VulkanSubresourceLayout.Builder

Enclosing class:
  `VulkanSubresourceLayout`

public static final class VulkanSubresourceLayout.Builder extends Object
Builds instances of type `VulkanSubresourceLayout`. Initialize attributes and then invoke the `build()` method to create an immutable instance.

`Builder` is not thread-safe and generally should not be stored in a field or collection, but instead used immediately to create instances.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `VulkanSubresourceLayout`
  `build()`
  Builds a new `VulkanSubresourceLayout`.
  `final VulkanSubresourceLayout.Builder`
  `from(VulkanSubresourceLayoutType instance)`
  Fill a builder with attribute values from the provided `VulkanSubresourceLayoutType` instance.
  `final VulkanSubresourceLayout.Builder`
  `setArrayPitch(long arrayPitch)`
  Initializes the value for the `arrayPitch` attribute.
  `final VulkanSubresourceLayout.Builder`
  `setDepthPitch(long depthPitch)`
  Initializes the value for the `depthPitch` attribute.
  `final VulkanSubresourceLayout.Builder`
  `setOffset(long offset)`
  Initializes the value for the `offset` attribute.
  `final VulkanSubresourceLayout.Builder`
  `setRowPitch(long rowPitch)`
  Initializes the value for the `rowPitch` attribute.
  `final VulkanSubresourceLayout.Builder`
  `setSize(long size)`
  Initializes the value for the `size` attribute.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Method Details

  - ### from

    public final VulkanSubresourceLayout.Builder from(VulkanSubresourceLayoutType instance)
    Fill a builder with attribute values from the provided `VulkanSubresourceLayoutType` instance. Regular attribute values will be replaced with those from the given instance. Absent optional values will not replace present values.
    Parameters:
      `instance` - The instance from which to copy values
    Returns:
      `this` builder for use in a chained invocation

  - ### setOffset

    public final VulkanSubresourceLayout.Builder setOffset(long offset)
    Initializes the value for the `offset` attribute.
    Parameters:
      `offset` - The value for offset
    Returns:
      `this` builder for use in a chained invocation

  - ### setSize

    public final VulkanSubresourceLayout.Builder setSize(long size)
    Initializes the value for the `size` attribute.
    Parameters:
      `size` - The value for size
    Returns:
      `this` builder for use in a chained invocation

  - ### setRowPitch

    public final VulkanSubresourceLayout.Builder setRowPitch(long rowPitch)
    Initializes the value for the `rowPitch` attribute.
    Parameters:
      `rowPitch` - The value for rowPitch
    Returns:
      `this` builder for use in a chained invocation

  - ### setArrayPitch

    public final VulkanSubresourceLayout.Builder setArrayPitch(long arrayPitch)
    Initializes the value for the `arrayPitch` attribute.
    Parameters:
      `arrayPitch` - The value for arrayPitch
    Returns:
      `this` builder for use in a chained invocation

  - ### setDepthPitch

    public final VulkanSubresourceLayout.Builder setDepthPitch(long depthPitch)
    Initializes the value for the `depthPitch` attribute.
    Parameters:
      `depthPitch` - The value for depthPitch
    Returns:
      `this` builder for use in a chained invocation

  - ### build

    public VulkanSubresourceLayout build()
    Builds a new `VulkanSubresourceLayout`.
    Returns:
      An immutable instance of VulkanSubresourceLayout
    Throws:
      `IllegalStateException` - if any required attributes are missing